//
//  MainListPresenterTests.swift
//  Marveler
//
//  Created by Arash on 12/8/21.
//  Copyright (c) 2021 ___ORGANIZATIONNAME___. All rights reserved.
//
//  This file was generated by the Clean Swift Xcode Templates so
//  you can apply clean architecture to your iOS and Mac projects,
//  see http://clean-swift.com
//

@testable import Marveler
import XCTest

class MainListPresenterTests: XCTestCase {
    // MARK: Subject under test
    
    var sut: MainListPresenter!
    
    // MARK: Test lifecycle
    
    override func setUp() {
        super.setUp()
        setupMainListPresenter()
    }
    
    override func tearDown() {
        super.tearDown()
    }
    
    // MARK: Test setup
    
    func setupMainListPresenter() {
        sut = MainListPresenter()
    }
    
    // MARK: Test doubles
    class MainListDisplayLogicSpy: MainListDisplayLogic {
        var displaySuccessPrepareCalled = false
        var displayServerErrorPrepareCalled = false
        var displayNoConnectionPrepareCalled = false
        var displayedList: [PopulatedResult] = []
        
        func displaySuccessPrepare(viewModel: MainList.Prepare.ViewModel.Success) {
            displayedList = viewModel.list
            displaySuccessPrepareCalled = true
        }
        
        func displayServerErrorPrepare(viewModel: MainList.Prepare.ViewModel.Failure) {
            displayServerErrorPrepareCalled = true
        }
        
        func displayNoConnectionPrepare(viewModel: MainList.Prepare.ViewModel.Failure) {
            displayNoConnectionPrepareCalled = true
        }
    
    }
    
    // MARK: testDisplaySuccessPrepareCalled
    func testDisplaySuccessPrepareCalled() {
        
        //Given
        let spy = MainListDisplayLogicSpy()
        sut.viewController = spy
        
        
        //When
        let response = MainList.Prepare.Response(result: .success(Seed.Main.characters), list: Seed.Main.list)
        sut.presentPrepare(response: response)
        
        //Then
        XCTAssertTrue(spy.displaySuccessPrepareCalled, "should ask the view Controller to display the result")
    }
    // MARK: testDisplayServerErrorPrepareCalled
    func testDisplayServerErrorPrepareCalled() {
        
        //Given
        let spy = MainListDisplayLogicSpy()
        sut.viewController = spy
        let error = CustomError(message: "a serious error!")
        let response = MainList.Prepare.Response(result: .failure(error), list: Seed.Main.list)
        
        //When
        sut.presentPrepare(response: response)
        
        //Then
        XCTAssertTrue(spy.displayServerErrorPrepareCalled, "should ask the view Controller to display the result")
    }
    
    // MARK: testDisplayNoConnectionPrepareCalled
    func testDisplayNoConnectionPrepareCalled() {
        
        //Given
        let spy = MainListDisplayLogicSpy()
        sut.viewController = spy
        let error = NoConnectionError()
        let response = MainList.Prepare.Response(result: .failure(error), list: Seed.Main.list)
        
        //When
        sut.presentPrepare(response: response)
        
        //Then
        XCTAssertTrue(spy.displayNoConnectionPrepareCalled, "should ask the view Controller to display the result")
    }
    
    // MARK: testDisplayNoConnectionPrepareCalled
    func testDisplayListCount() {
        
        //Given
        let spy = MainListDisplayLogicSpy()
        sut.viewController = spy
        let response = MainList.Prepare.Response(result: .success(Seed.Main.characters), list: Seed.Main.list)
        
        //When
        sut.presentPrepare(response: response)
        
        //Then
        XCTAssertEqual(spy.displayedList.count, Seed.Main.list.count, "should be equal")
    }
}
